%module _surfit
%include typemaps.i
%{
#include "Python.h"
#include "arrayobject.h"
extern void surfit_(int *iopt, int *m, float *x, float *y, float *z, float *w,
	    float *xb, float *xe, float *yb, float *ye, int *kx, int
	    *ky, float *s, int *nxest, int *nyest, int *nmax, float
	    *eps, int *nx, float *tx, int *ny, float *ty, float *c,
	    float *fp, float *wrk1, int *lwrk1, float *wrk2, int
	    *lwrk2, int *iwrk, int *kwrk, int *ier);
extern void bispev_(float *tx, int *nx, float *ty, int *ny, float *c, int
		    *kx, int *ky, float *x, int *mx, float *y, int *my, float
		    *z, float *wrk, int *lwrk, int *iwrk, int *kwrk,
		    int *ier);
int MAIN__(void) { return 0; }
%}

%init %{
	import_array();
%}

%typemap(python,in) float * {
  /* Check to see if input is a NumPy array and if it is of type FLOAT */
  PyArrayObject *arr;
  arr = (PyArrayObject *) $source;
  if (!(PyArray_Check($source)) || (arr->descr->type_num != PyArray_FLOAT)) {
        PyErr_SetString(PyExc_TypeError,"Argument must be a float NumPy array.");
        return NULL;
  }
  $target = (float *)arr->data;
}

%typemap(python,in) int * {
  /* Check to see if input is a NumPy array and if it is integer */
  PyArrayObject *arr;
  arr = (PyArrayObject *) $source;
  if (!PyArray_Check($source) || arr->descr->type_num != PyArray_INT ) {
        PyErr_SetString(PyExc_TypeError,"Argument must be an integer NumPy array.");
        return NULL;
  }
  $target = (int *)arr->data;
}

void surfit_(
    int *INPUT /*iopt*/, int *INPUT /*m*/, float * /*x*/, 
    float * /*y*/, float * /*z*/, float * /*w*/,
    float *INPUT /*xb*/, float *INPUT /*xe*/, float *INPUT /*yb*/, 
    float *INPUT /*ye*/, int *INPUT /*kx*/, int *INPUT /*ky*/, 
    float *INPUT /*s*/, int *INPUT /*nxest*/, int *INPUT /*nyest*/, 
    int *INPUT /*nmax*/, float *INPUT /*eps*/, int *BOTH /*nx*/, 
    float * /*tx*/, int * BOTH/*ny*/, float * /*ty*/, 
    float * /*c*/, float *OUTPUT /*fp*/, float * /*wrk1*/, 
    int *INPUT /*lwrk1*/, float * /*wrk2*/, int *INPUT /*lwrk2*/, 
    int * /*iwrk*/, int *INPUT /*kwrk*/, int *OUTPUT /*ier*/
);
void bispev_(
    float * /*tx*/, int *INPUT /*nx*/, float * /*ty*/, 
    int *INPUT /*ny*/, float * /*c*/, int *INPUT /*kx*/, 
    int *INPUT /*ky*/, float * /*x*/, int *INPUT /*mx*/, 
    float * /*y*/, int *INPUT /*my*/, float * /*z*/, 
    float * /*wrk*/, int *INPUT /*lwrk*/, int * /*iwrk*/, 
    int *INPUT /*kwrk*/, int *OUTPUT /*ier*/
);
